//KaizenRelayCAN.h
//Version 2.0 - 2021 November 9
//CANtrolls, LLC. - Vadim Belogorodsky

#ifndef KAIZENRELAY_CAN_H
#define KAIZENRELAY_CAN_H

#include "KaizenRelay.h"
#include "KaizenRelayEEPROM.h"

#include "mcp_can.h"

MCP_CAN CAN_(PIN_CAN_CS);

//Function Prototypes:
void SetupCAN_125kbps();
void SetupCAN_250kbps();
void SetupCAN_500kbps();
void SetupCAN_1000kbps();

void CANListenMsg();

void SendHWStatusCAN();
void CANConfigCMsgLogic();

void SetupCAN_125kbps()
{
  CAN_BaudRate = 125;
  
  //Start CAN Network at 125kbps Baudrate
  while (CAN_OK != CAN_.begin(CAN_125KBPS)) delay(100);

  //Clear CAN Read Buffer
  for(unsigned short i = 0; i < 8; i++) CAN_Read_Msg[i] = 0x00;
}

void SetupCAN_250kbps()
{
  CAN_BaudRate = 250;
  
  //Start CAN Network at 250kbps Baudrate
  while (CAN_OK != CAN_.begin(CAN_250KBPS)) delay(100);

  //Clear CAN Read Buffer
  for(unsigned short i = 0; i < 8; i++) CAN_Read_Msg[i] = 0x00;
}

void SetupCAN_500kbps()
{
  CAN_BaudRate = 500;
  
  //Start CAN Network at 500kbps Baudrate
  while (CAN_OK != CAN_.begin(CAN_500KBPS)) delay(100);

  //Clear CAN Read Buffer
  for(unsigned short i = 0; i < 8; i++) CAN_Read_Msg[i] = 0x00;
}

void SetupCAN_1000kbps()
{
  CAN_BaudRate = 1000;
  
  //Start CAN Network at 1000kbps Baudrate
  while (CAN_OK != CAN_.begin(CAN_1000KBPS)) delay(100);

  //Clear CAN Read Buffer
  for(unsigned short i = 0; i < 8; i++) CAN_Read_Msg[i] = 0x00;
}

void EnableCANTermResistor()
{
  CAN_TermRes_Enabled = true;         digitalWrite(PIN_CAN_TERM, !CAN_TermRes_Enabled);
  EEPROM.update(ADDR_CAN_TermRes_Enabled, CAN_TermRes_Enabled);
}

void DisableCANTermResistor()
{
  CAN_TermRes_Enabled = false;        digitalWrite(PIN_CAN_TERM, !CAN_TermRes_Enabled);
  EEPROM.update(ADDR_CAN_TermRes_Enabled, CAN_TermRes_Enabled);
}

void SendHWStatusCAN()
{
  if(CAN_Msg_Counter == 0)
  {
    if(Output_1_Mode == 1)
    {
      if(Output_1_Duty > 0) CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] | 0x01);
      else CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] & 0xFE);
    }

    else if(Output_1_Mode == 2)
    {
      if(Output_1_Digital) CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] | 0x01);
      else CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] & 0xFE);
    }
    
    else CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] & 0xFE);

    if(Output_1_Mode == 1) CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] | 0x02);
    else CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] & 0xFD);

    if(Output_1_Mode == 2) CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] | 0x04);
    else CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] & 0xFB);
/*
    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x08)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xF7);
    
    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x10)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xEF);

    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x20)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xDF);

    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x40)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xBF);
*/
    if(Output_1_Digital) CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] | 0x80);
    else CAN_Status_Msg_1[0] = (CAN_Status_Msg_1[0] & 0x7F);

    if((Output_1_Mode == 1) && (Output_1_PWMFreq == 10)) CAN_Status_Msg_1[1] = (CAN_Status_Msg_1[1] | 0x01);
      else CAN_Status_Msg_1[1] = (CAN_Status_Msg_1[1] & 0xFE);
      
    if((Output_1_Mode == 1) && (Output_1_PWMFreq == 50)) CAN_Status_Msg_1[1] = (CAN_Status_Msg_1[1] | 0x02);
    else CAN_Status_Msg_1[1] = (CAN_Status_Msg_1[1] & 0xFD);

    if((Output_1_Mode == 1) && (Output_1_PWMFreq == 100)) CAN_Status_Msg_1[1] = (CAN_Status_Msg_1[1] | 0x04);
    else CAN_Status_Msg_1[1] = (CAN_Status_Msg_1[1] & 0xFB);
/*
    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x08)
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xF7);
    
    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x10);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xEF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x20);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xDF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x40);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xBF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x80);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0x7F);
*/

    CAN_Status_Msg_1[2] = Output_1_Duty;

    CAN_Status_Msg_1[3] = 0xFF;
    CAN_Status_Msg_1[4] = 0xFF;
    CAN_Status_Msg_1[5] = 0xFF;
    CAN_Status_Msg_1[6] = 0xFF;
    CAN_Status_Msg_1[7] = 0xFF;

    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_1);    
  }




  if(CAN_Msg_Counter == 1)
  {
    if(Output_2_Mode == 1)
    {
      if(Output_2_Duty > 0) CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] | 0x01);
      else CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] & 0xFE);
    }

    else if(Output_2_Mode == 2)
    {
      if(Output_2_Digital) CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] | 0x01);
      else CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] & 0xFE);
    }
    
    else CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] & 0xFE);

    if(Output_2_Mode == 1) CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] | 0x02);
    else CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] & 0xFD);

    if(Output_2_Mode == 2) CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] | 0x04);
    else CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] & 0xFB);

/*
    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x08)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xF7);
    
    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x10)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xEF);

    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x20)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xDF);

    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x40)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xBF);
*/
    if(Output_2_Digital) CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] | 0x80);
    else CAN_Status_Msg_2[0] = (CAN_Status_Msg_2[0] & 0x7F);

    

    if((Output_2_Mode == 1) && (Output_2_PWMFreq == 10)) CAN_Status_Msg_2[1] = (CAN_Status_Msg_2[1] | 0x01);
      else CAN_Status_Msg_2[1] = (CAN_Status_Msg_2[1] & 0xFE);
      
    if((Output_2_Mode == 1) && (Output_2_PWMFreq == 50)) CAN_Status_Msg_2[1] = (CAN_Status_Msg_2[1] | 0x02);
    else CAN_Status_Msg_2[1] = (CAN_Status_Msg_2[1] & 0xFD);

    if((Output_2_Mode == 1) && (Output_2_PWMFreq == 100)) CAN_Status_Msg_2[1] = (CAN_Status_Msg_2[1] | 0x04);
    else CAN_Status_Msg_2[1] = (CAN_Status_Msg_2[1] & 0xFB);
/*
    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x08);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xF7);
    
    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x10);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xEF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x20);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xDF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x40);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xBF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x80);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0x7F);
*/

    CAN_Status_Msg_2[2] = Output_2_Duty;

    CAN_Status_Msg_2[3] = 0xFF;
    CAN_Status_Msg_2[4] = 0xFF;
    CAN_Status_Msg_2[5] = 0xFF;
    CAN_Status_Msg_2[6] = 0xFF;
    CAN_Status_Msg_2[7] = 0xFF;

    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_2);    
  }

  if(CAN_Msg_Counter == 2)
  {
    if(Output_3_Mode == 1)
    {
      if(Output_3_Duty > 0) CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] | 0x01);
      else CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] & 0xFE);
    }

    else if(Output_3_Mode == 2)
    {
      if(Output_3_Digital) CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] | 0x01);
      else CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] & 0xFE);
    }

    else CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] & 0xFE);

    if(Output_3_Mode == 1) CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] | 0x02);
    else CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] & 0xFD);

    if(Output_3_Mode == 2) CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] | 0x04);
    else CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] & 0xFB);
/*
    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x08)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xF7);
    
    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x10)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xEF);

    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x20)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xDF);

    if() CAN_Status_Msg[0] = (CAN_Status_Msg[0] | 0x40)
    else CAN_Status_Msg[0] = (CAN_Status_Msg[0] & 0xBF);
*/
    if(Output_3_Digital) CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] | 0x80);
    else CAN_Status_Msg_3[0] = (CAN_Status_Msg_3[0] & 0x7F);

    

    if((Output_3_Mode == 1) && (Output_3_PWMFreq == 10)) CAN_Status_Msg_3[1] = (CAN_Status_Msg_3[1] | 0x01);
      else CAN_Status_Msg_3[1] = (CAN_Status_Msg_3[1] & 0xFE);
      
    if((Output_3_Mode == 1) && (Output_3_PWMFreq == 50)) CAN_Status_Msg_3[1] = (CAN_Status_Msg_3[1] | 0x02);
    else CAN_Status_Msg_3[1] = (CAN_Status_Msg_3[1] & 0xFD);

    if((Output_3_Mode == 1) && (Output_3_PWMFreq == 100)) CAN_Status_Msg_3[1] = (CAN_Status_Msg_3[1] | 0x04);
    else CAN_Status_Msg_3[1] = (CAN_Status_Msg_3[1] & 0xFB);
/*
    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x08)
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xF7);
    
    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x10);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xEF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x20);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xDF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x40);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0xBF);

    if() CAN_Status_Msg[1] = (CAN_Status_Msg[1] | 0x80);
    else CAN_Status_Msg[1] = (CAN_Status_Msg[1] & 0x7F);
*/

    CAN_Status_Msg_3[2] = Output_3_Duty;

    CAN_Status_Msg_3[3] = 0xFF;
    CAN_Status_Msg_3[4] = 0xFF;
    CAN_Status_Msg_3[5] = 0xFF;
    CAN_Status_Msg_3[6] = 0xFF;
    CAN_Status_Msg_3[7] = 0xFF;

    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_3);    
  }

  if(CAN_Msg_Counter == 3)
  {
    if(Input_1_Mode == 1) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x01);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xFE);

    if(Input_1_Mode == 2) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x02);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xFD);

    if(Input_1_Pullup_Enabled) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x04);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xFB);
    
    if(Input_1_Pulldown_Enabled) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x08);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xF7);
    
    if((Input_1_Mode == 1) && Input_1_Smoothing_Enabled) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x10);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xEF);

    if((Input_1_Mode == 2) && Input_1_Invert) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x20);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xDF);

    if((Input_1_Mode == 2) && Input_1_Digital) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x40);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0xBF);
    
    if(Input_1_5V_Enabled) CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] | 0x80);
    else CAN_Status_Msg_4[0] = (CAN_Status_Msg_4[0] & 0x7F);

    if(Input_1_Mode == 1)
    {
      unsigned int uiInput_1_Voltage = (unsigned int)(Input_1_Voltage * 100.0);
      CAN_Status_Msg_4[1] = (uiInput_1_Voltage >> 8) & 0xFF;
      CAN_Status_Msg_4[2] = (uiInput_1_Voltage & 0xFF);

      CAN_Status_Msg_4[3] = Input_1_Smoothing;
    }
    else
    {
      CAN_Status_Msg_4[1] = 0;
      CAN_Status_Msg_4[2] = 0;
      CAN_Status_Msg_4[3] = 0;
    }

    CAN_Status_Msg_4[4] = 0xFF;
    CAN_Status_Msg_4[5] = 0xFF;
    CAN_Status_Msg_4[6] = 0xFF;
    CAN_Status_Msg_4[7] = 0xFF;

    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_4);    
  }

  if(CAN_Msg_Counter == 4)
  {
    if(Input_2_Mode == 1) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x01);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xFE);

    if(Input_2_Mode == 2) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x02);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xFD);

    if(Input_2_Pullup_Enabled) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x04);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xFB);
    
    if(Input_2_Pulldown_Enabled) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x08);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xF7);
    
    if((Input_2_Mode == 1) && Input_2_Smoothing_Enabled) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x10);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xEF);

    if((Input_2_Mode == 2) && Input_2_Invert) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x20);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xDF);

    if((Input_2_Mode == 2) && Input_2_Digital) CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] | 0x40);
    else CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0xBF);
    
    CAN_Status_Msg_5[0] = (CAN_Status_Msg_5[0] & 0x7F); 

    if(Input_2_Mode == 1)
    {
      unsigned int uiInput_2_Voltage = (unsigned int)(Input_2_Voltage * 100.0);
      CAN_Status_Msg_5[1] = (uiInput_2_Voltage >> 8) & 0xFF;
      CAN_Status_Msg_5[2] = (uiInput_2_Voltage & 0xFF);

      CAN_Status_Msg_5[3] = Input_2_Smoothing;
    }
    else
    {
      CAN_Status_Msg_5[1] = 0;
      CAN_Status_Msg_5[2] = 0;
      CAN_Status_Msg_5[3] = 0;
    }

    CAN_Status_Msg_5[4] = 0xFF;
    CAN_Status_Msg_5[5] = 0xFF;
    CAN_Status_Msg_5[6] = 0xFF;
    CAN_Status_Msg_5[7] = 0xFF;

    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_5);    
  }

  if(CAN_Msg_Counter == 5)
  {
    if(Input_3_Mode == 1) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x01);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xFE);

    if(Input_3_Mode == 2) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x02);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xFD);

    if(Input_3_Pullup_Enabled) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x04);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xFB);
    
    if(Input_3_Pulldown_Enabled) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x08);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xF7);
    
    if((Input_3_Mode == 1) && Input_3_Smoothing_Enabled) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x10);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xEF);

    if((Input_3_Mode == 2) && Input_3_Invert) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x20);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xDF);

    if((Input_3_Mode == 2) && Input_3_Digital) CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] | 0x40);
    else CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0xBF);
    
    CAN_Status_Msg_6[0] = (CAN_Status_Msg_6[0] & 0x7F); 

    if(Input_3_Mode == 1)
    {
      unsigned int uiInput_3_Voltage = (unsigned int)(Input_3_Voltage * 100.0);
      CAN_Status_Msg_6[1] = (uiInput_3_Voltage >> 8) & 0xFF;
      CAN_Status_Msg_6[2] = (uiInput_3_Voltage & 0xFF);

      CAN_Status_Msg_6[3] = Input_3_Smoothing;
    }
    else
    {
      CAN_Status_Msg_6[1] = 0;
      CAN_Status_Msg_6[2] = 0;
      CAN_Status_Msg_6[3] = 0;
    }

    CAN_Status_Msg_6[4] = 0xFF;
    CAN_Status_Msg_6[5] = 0xFF;
    CAN_Status_Msg_6[6] = 0xFF;
    CAN_Status_Msg_6[7] = 0xFF;

    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_6);    
  }

  if(CAN_Msg_Counter == 6)
  {
    if(CAN_TermRes_Enabled) CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] | 0x01);
    else CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xFE);

    if(LED_Green_Status) CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] | 0x02);
    else CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xFD);

    if(LED_Red_Status) CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] | 0x04);
    else CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xFB);

    CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xF7);
    CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xEF);
    CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xDF);
    CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0xBF);
    CAN_Status_Msg_7[0] = (CAN_Status_Msg_7[0] & 0x7F); 

    CAN_Status_Msg_7[1] = 0xFF;
    CAN_Status_Msg_7[2] = 0xFF;
    CAN_Status_Msg_7[3] = 0xFF;
    CAN_Status_Msg_7[4] = 0xFF;
    CAN_Status_Msg_7[5] = 0xFF;
    CAN_Status_Msg_7[6] = 0xFF;
    CAN_Status_Msg_7[7] = 0xFF;
    
    CAN_.sendMsgBuf(CAN_Base_Address + CAN_Msg_Counter, 0, 8, CAN_Status_Msg_7); 
  }

  CAN_Msg_Counter++;
  if(CAN_Msg_Counter > 6) CAN_Msg_Counter = 0;
}

void CANConfigCMsgLogic()
{
  /*
  //Output Command Mode:
  if(CAN_Read_Msg[0] == 0x00) 
  {
    Output_1_Mode = CAN_Read_Msg[1]; //0 = Unused, 1 = PWM, 2 = Digital
    Output_2_Mode = CAN_Read_Msg[2]; //0 = Unused, 1 = PWM, 2 = Digital
    Output_3_Mode = CAN_Read_Msg[3]; //0 = Unused, 1 = PWM, 2 = Digital

    if(Output_1_Mode == 1) 
    {
      Output_1_Digital = false; 
      if(CAN_Read_Msg[4] <= 100) Output_1_Duty = CAN_Read_Msg[4];
      else Output_1_Duty = 0;
    }
    else if(Output_1_Mode == 2)  
    {
      Output_1_Duty = 0; 
      Output_1_Digital = (CAN_Read_Msg[4] > 0);
    }
    else {Output_1_Duty = 0; Output_1_Digital = false;}

    if(Output_2_Mode == 1) 
    {
      Output_2_Digital = false; 
      if(CAN_Read_Msg[5] <= 100) Output_2_Duty = CAN_Read_Msg[5];
      else Output_2_Duty = 0;
    }
    else if(Output_2_Mode == 2)  
    {
      Output_2_Duty = 0; 
      Output_2_Digital = (CAN_Read_Msg[5] > 0);
    }
    else {Output_2_Duty = 0; Output_2_Digital = false;}
    
    if(Output_3_Mode == 1) 
    {
      Output_3_Digital = false; 
      if(CAN_Read_Msg[6] <= 100) Output_3_Duty = CAN_Read_Msg[6];
      else Output_3_Duty = 0;
    }
    else if(Output_3_Mode == 2)  
    {
      Output_3_Duty = 0; 
      Output_3_Digital = (CAN_Read_Msg[6] > 0);
    }
    else {Output_3_Duty = 0; Output_3_Digital = false;}
  }
    
  //CAN Config Mode:  
  if(CAN_Read_Msg[0] == 0xFF)
  {
    if(((CAN_Read_Msg[1] * 256) + CAN_Read_Msg[2]) < 0x7FF)
    {
      EnableGreenLED();
      CAN_Command_Msg_ID = ((CAN_Read_Msg[1] * 256) + CAN_Read_Msg[2]);
      EEPROM.put(ADDR_CAN_Command_Msg_ID, CAN_Command_Msg_ID); 
      DisableGreenLED();
    }
  }
  */
}

#endif
