//KaizenRelay Template
//Version 3.0 - 2021 December 29
//CANtrolls, LLC. - Vadim Belogorodsky

void EnableGreenLED();
void DisableGreenLED();

void EnableRedLED();
void DisableRedLED();

#include "KaizenRelay.h"

#define UseGenericCANRx 1               
#define UseGenericCANTx 1

//Program Variable Area:


void setup() 
{
  //Setup Pins and CAN Timer:
  HardwareSetup();

  //Input Pin 1 Setup:
  //Enable5VSupply();
  //Disable5VSupply();
  //EnableInput1Pullup();
  //DisableInput1Pullup();
  //EnableInput1Pulldown();
  //DisableInput1Pulldown();
  DisableInput1Switches();

  //Input Pin 2 Setup:
  //EnableInput2Pullup();
  //DisableInput2Pullup();
  //EnableInput2Pulldown();
  //DisableInput2Pulldown();
  DisableInput2Switches();

  //Input Pin 3 Setup:
  //EnableInput3Pullup();
  //DisableInput3Pullup();
  //EnableInput3Pulldown();
  //DisableInput3Pulldown();
  DisableInput3Switches();
  
  //Output PWM Setup:
  //SetupPWM10Hz();
  //SetupPWM50Hz();
  //SetupPWM100Hz();

  //Output Pin 1 Setup:
  Output_1_Mode = 0;

  //Output Pin 2 Setup:
  Output_2_Mode = 0;

  //Output Pin 3 Setup:
  Output_3_Mode = 0;

  //CAN Baud Rate Setup:
  //SetupCAN_125kbps();
  //SetupCAN_250kbps();
  SetupCAN_500kbps();
  //SetupCAN_1000kbps();
  
  //CAN Termination Resistor:
  //EnableCANTermResistor();
  DisableCANTermResistor();

  //Setup USB Interface
  Serial.begin(57600);
}

void loop() 
{
  //Check if CAN Messages are Available
  if(CAN_MSGAVAIL == CAN_.checkReceive())
  {
    //Read in CAN Message Length and Data
    CAN_.readMsgBuf(&CAN_Read_Len, CAN_Read_Msg);

    //Read in CAN Message ID
    CAN_Read_ID = CAN_.getCanId();

    //Generic CAN Listen
    if(UseGenericCANRx)
  	{
  		if((CAN_Read_ID >= CAN_Base_Address + 7) && (CAN_Read_ID <= CAN_Base_Address + 10)) 
  			CANListenMsg();
  	}
    CAN_MissedMsgs = 0;
  }
  else CAN_MissedMsgs++;

  CAN_Timeout = (CAN_MissedMsgs > 10000);

  //Variable Overflow Handle
  if(CAN_MissedMsgs > 60000) CAN_MissedMsgs = 11000;

  //Check if Serial Messages are Available()
  if(Serial.available())
  {    
    while(Serial.available()) 
    {
      SerialInput += (char)Serial.read();
    }

    SerialIndex = SerialInput.substring(0, 3);
    SerialData = SerialInput.substring(4, SerialInput.length());

    ReadHWStatusUSB();
    
    SerialInput = "";    
  }

  if(Flag10ms)
  {
    Timer10ms(); 
    Flag10ms = false;
  }

  if(Flag20ms)
  {
    Timer20ms(); 
    Flag20ms = false;
  }

  if(Flag50ms)
  {
    Timer50ms(); 
    Flag50ms = false;
  }
  
  if(Flag100ms)
  {
    Timer100ms(); 
    Flag100ms = false;
  }
  
  if(Flag500ms)
  {
    Timer500ms(); 
    Flag500ms = false;
  }

  if(Flag1000ms)
  {
    Timer1000ms(); 
    Flag1000ms = false;
  }
}

void USB_Write()
{
  //User Area for USB Writing - Message Beginning "**"
  Serial.print("**");

  //Place Your Required Text Output Here:
  
  //Message Ending ";"
  Serial.println(";");
} 
void Timer10ms()
{
  if(UseGenericCANTx) SendHWStatusCAN();
}

void Timer20ms()
{
  
}

void Timer50ms()
{
  SendHWStatusUSB();
}

void Timer100ms()
{
  
}

void Timer500ms()
{
  
}

void Timer1000ms()
{
  USB_Write();

  //Generic CAN Listen
  if(UseGenericCANRx)
  {
    if(CAN_Timeout)
    {
      //CAN Error
      if(Output_1_Mode == 1) Output_1_Duty = 0; 
      if(Output_1_Mode == 2) DisableOutput1Digital(); 
      Output_1_Mode = 0; 
  
      if(Output_2_Mode == 1) Output_2_Duty = 0;
      if(Output_2_Mode == 2) DisableOutput2Digital();
      Output_2_Mode = 0; 
  
      if(Output_3_Mode == 1) Output_3_Duty = 0;
      if(Output_3_Mode == 2) DisableOutput3Digital();
      Output_3_Mode = 0; 
  
      DisableGreenLED();
      DisableRedLED();
    }  
  }
}



ISR(TIMER1_COMPA_vect) //Timer1 Interrupt 
{
  PWMpulseCounter++;
  if(PWMpulseCounter >= 99) PWMpulseCounter = 0;

  //Port Manipulation:
  
/*  
  //Green LED: PD1
  if(xxx)
  {
    if(PWMpulseCounter < Output_x_Duty) PORTD = PORTD | 0b00000010;
    else                                PORTD = PORTD & 0b11111101; 
  }

  //Red LED: PD0
  if(xxx)
  {
    if(PWMpulseCounter < Output_y_Duty) PORTD = PORTD | 0b00000001;
    else                                PORTD = PORTD & 0b11111110; 
  }

*/
  
  //Output 1: PB5
  if(Output_1_Mode == 1)
  {
    if(PWMpulseCounter < Output_1_Duty) PORTB = PORTB | 0b00100000;
    else                                PORTB = PORTB & 0b11011111; 
  }
  
  //Output 2: PC7
  if(Output_2_Mode == 1)
  {
    if(PWMpulseCounter < Output_2_Duty) PORTC = PORTC | 0b10000000;
    else                                PORTC = PORTC & 0b01111111;
  }
    
  //Output 3: PC6  
  if(Output_3_Mode == 1)
  {
    if(PWMpulseCounter < Output_3_Duty) PORTC = PORTC | 0b01000000;
    else                                PORTC = PORTC & 0b10111111;
  }
}

void CANListenMsg()
{
  if(CAN_Read_ID == (CAN_Base_Address + 7))
  {
    if(CAN_Read_Msg[0] == 0x01)
    {
      Output_1_Mode = 2;
    }
    else if (CAN_Read_Msg[0] == 0x02)
    {
      Output_1_Mode = 1;
      if(Output_1_PWMFreq != 10) SetupPWM10Hz();
    }

    else if (CAN_Read_Msg[0] == 0x04)
    {
      Output_1_Mode = 1;
      if(Output_1_PWMFreq != 50) SetupPWM50Hz();
    }

    else if (CAN_Read_Msg[0] == 0x08)
    {
      Output_1_Mode = 1;
      if(Output_1_PWMFreq != 100) SetupPWM100Hz();
    }
    else 
    {
      Output_1_Digital = false;
      Output_1_Duty = 0;
      Output_1_Mode = 0;
    }

    if(Output_1_Mode == 2)
    {
      if(CAN_Read_Msg[1]) EnableOutput1Digital();
      else DisableOutput1Digital();
    }

    if(Output_1_Mode == 1)
    {
      DisableOutput1Digital();
      if(CAN_Read_Msg[1] <= 100) Output_1_Duty = CAN_Read_Msg[1];
      else Output_1_Duty = 0;      
    }
  }

  if(CAN_Read_ID == (CAN_Base_Address + 8))
  {
    if(CAN_Read_Msg[0] == 0x01)
    {
      Output_2_Mode = 2;
    }
    else if (CAN_Read_Msg[0] == 0x02)
    {
      Output_2_Mode = 1;
      if(Output_2_PWMFreq != 10) SetupPWM10Hz();
    }

    else if (CAN_Read_Msg[0] == 0x04)
    {
      Output_2_Mode = 1;
      if(Output_2_PWMFreq != 50) SetupPWM50Hz();
    }

    else if (CAN_Read_Msg[0] == 0x08)
    {
      Output_2_Mode = 1;
      if(Output_2_PWMFreq != 100) SetupPWM100Hz();
    }
    else 
    {
      Output_2_Digital = false;
      Output_2_Duty = 0;
      Output_2_Mode = 0;
    }

    if(Output_2_Mode == 2)
    {
      if(CAN_Read_Msg[1]) EnableOutput2Digital();
      else DisableOutput2Digital();
    }

    if(Output_2_Mode == 1)
    {
      DisableOutput2Digital();
      if(CAN_Read_Msg[1] <= 100) Output_2_Duty = CAN_Read_Msg[1];
      else Output_2_Duty = 0;      
    }
  }

  if(CAN_Read_ID == (CAN_Base_Address + 9))
  {
    if(CAN_Read_Msg[0] == 0x01)
    {
      Output_3_Mode = 2;
    }
    else if (CAN_Read_Msg[0] == 0x02)
    {
      Output_3_Mode = 1;
      if(Output_3_PWMFreq != 10) SetupPWM10Hz();
    }

    else if (CAN_Read_Msg[0] == 0x04)
    {
      Output_3_Mode = 1;
      if(Output_3_PWMFreq != 50) SetupPWM50Hz();
    }

    else if (CAN_Read_Msg[0] == 0x08)
    {
      Output_3_Mode = 1;
      if(Output_3_PWMFreq != 100) SetupPWM100Hz();
    }
    else
    {
      Output_3_Digital = false;
      Output_3_Duty = 0;
      Output_3_Mode = 0;
    }

    if(Output_3_Mode == 2)
    {
      if(CAN_Read_Msg[1]) EnableOutput3Digital();
      else DisableOutput3Digital();
    }

    if(Output_3_Mode == 1)
    {
      DisableOutput3Digital();
      if(CAN_Read_Msg[1] <= 100) Output_3_Duty = CAN_Read_Msg[1];
      else Output_3_Duty = 0;      
    }
  }

  if(CAN_Read_ID == (CAN_Base_Address + 10))
  {
    if(CAN_Read_Msg[0] & 0x01) EnableCANTermResistor();
    else DisableCANTermResistor();

    if(CAN_Read_Msg[0] & 0x02) EnableGreenLED();
    else DisableGreenLED();

    if(CAN_Read_Msg[0] & 0x04) EnableRedLED();
    else DisableRedLED();
  }
}
